// H to Pas Converter Ver.1.19.1.46 by K.Kumaki
//     Date : 19 May 2004
//   Source : Coef_v.h (11 May 2004)

unit Coef_v;

{$X+}{$Z2}{$A8}

interface

uses Windows,Direct3D8;

//-----------------------------------------------------------------------------
//
// (c) 2002-2003 @http://www5d.biglobe.ne.jp/~ochikko
//
//-----------------------------------------------------------------------------

{$IFNDEF COEFVH}
{$DEFINE COEFVH}

// Error :  #include < D3DX8.h >

const
  //u_long	= ULONG;

  GBANDVAL	= 4000.0;

  TYPENAMELENG	= 500;

  PATH_LENG	= 2048;

  TREEDEPTHMAX	= 50;

type
  p_MPINFO = ^MPINFO;
  MPINFO = record
	qid	: Integer;
	tra	: TD3DVector;
	frameno	: Integer;
	dispswitch	: Integer;
	interpolation	: Integer;
	reserved1	: Integer;
	reserved2	: Integer;
	reserved3	: Integer;
	reserved4	: Integer;
  end;


type
  p_GUARDBAND = ^GUARDBAND;
  GUARDBAND = record
	left	: Single;
	top	: Single;
	right	: Single;
	bottom	: Single;
	maxrhw	: Single;
  end;


  VEC3F = record
	x	: Single;
	y	: Single;
	z	: Single;
  end;
  LOCATION	= VEC3F;
  ROTATE	= VEC3F;
  p_VEC3F = ^VEC3F;


  LPD3DTLVERTEX	= ^D3DTLVERTEX;
  D3DTLVERTEX = record
	sx, sy	: Single;	// XN[W
	sz	: Single;	// Z obt@[x
	rhw	: Single;	//  W ̋t
	color	: DWORD;	// fBt[YF
	specular	: DWORD;	// XyLF
	tu, tv	: Single;	// eNX`W
  end;

  LPD3DTLVERTEX2	= ^D3DTLVERTEX2;
  D3DTLVERTEX2 = record
	// texture Q
	sx, sy	: Single;	// XN[W
	sz	: Single;	// Z obt@[x
	rhw	: Single;	//  W ̋t
	color	: DWORD;	// fBt[YF
	specular	: DWORD;	// XyLF
	tu1, tv1	: Single;	// eNX`W
	tu2, tv2	: Single;
  end;

  {TEnum_Coef_v1 = (
	 MOTION_IDLE,
	 MOTION_KICK,
	 MOTION_PUNCH,
	 MOTION_ACT1,
	 MOTION_DEFENSE,
	 MOTION_DEATH,
	 MOTION_WIN,
	 MOTION_MAX
	 );}

const

  MOTION_IDLE=0;
  MOTION_KICK=1;
  MOTION_PUNCH=2;
  MOTION_ACT1=3;
  MOTION_DEFENSE=4;
  MOTION_DEATH=5;
  MOTION_WIN=6;
  MOTION_MAX=7;

  FIGHTINGTIME	= 120;
//#define FIGHTINGTIME		400

type
  TEnum_Coef_v2 = (
	 ENDFLAG_NONE,
	 ENDFLAG_KO,
	 ENDFLAG_TIMEUP,
	 ENDFLAG_OUTOFRANGE,
	 ENDFLAG_MAX
	 );

// error code
// d3dapp.h ړB

{$IFNDEF D3DAPPERR_NODIRECT3D}
  APPMSGTYPE = ( MSG_NONE, MSGERR_APPMUSTEXIT, MSGWARN_SWITCHEDTOREF );

const
  D3DAPPERR_NODIRECT3D	= $82000001;
  D3DAPPERR_NOWINDOW	= $82000002;
  D3DAPPERR_NOCOMPATIBLEDEVICES	= $82000003;
  D3DAPPERR_NOWINDOWABLEDEVICES	= $82000004;
  D3DAPPERR_NOHARDWAREDEVICE	= $82000005;
  D3DAPPERR_HALNOTCOMPATIBLE	= $82000006;
  D3DAPPERR_NOWINDOWEDHAL	= $82000007;
  D3DAPPERR_NODESKTOPHAL	= $82000008;
  D3DAPPERR_NOHALTHISMODE	= $82000009;
  D3DAPPERR_NONZEROREFCOUNT	= $8200000a;
  D3DAPPERR_MEDIANOTFOUND	= $8200000b;
  D3DAPPERR_RESIZEFAILED	= $8200000c;

{$ENDIF}

type
  p_ERRORMES = ^ERRORMES;
  ERRORMES = record
	errorcode	: Integer;
	Etype 	: DWORD;
	mesptr	: PChar;
  end;



//WM_USER_KEY  WPARAM
const
  ID_KEY_LEFT	= 1;
  ID_KEY_RIGHT	= 2;
  ID_KEY_UP	= 3;
  ID_KEY_DOWN	= 4;
  ID_KEY_ZOOMIN	= 5;
  ID_KEY_ZOOMOUT	= 6;
  ID_KEY_TARGET_LEFT	= 7;
  ID_KEY_TARGET_RIGHT	= 8;

  ID_KEY_RAD2_UP	= 9;
  ID_KEY_RAD2_DOWN	= 10;

  ID_KEY_UD_RESET	= 20;
  ID_KEY_ROT_RESET	= 21;
  ID_KEY_ZOOM_RESET	= 22;
  ID_KEY_TARGET_RESET	= 23;
  ID_KEY_ALL_RESET	= 24;

  ID_KEY_RAD2_RESET	= 25;


  PI	= 3.14159265358979323846;
  PAI	= 3.14159265359;
  PAIDIV2	= 1.570796326795;
  PAIDIV4	= 0.7853981633974;
  PAI2DEG	= 57.29577951308;
  DEG2PAI	= 0.01745329251994;
  D2R	= 0.01745329251994;

////////////////////////////////
type
  _projmode = (
	 PROJ_NORMAL,
	 PROJ_LENS,
	 PROJ_PREINIT, // init colorÓAtransformp
	 PROJ_MAX
	 );

////////////////////////////////
const
  D3DFVF_TLVERTEX	=  ( D3DFVF_XYZRHW or D3DFVF_DIFFUSE or D3DFVF_SPECULAR or D3DFVF_TEX1
         );
  D3DFVF_TLVERTEX2	=  ( D3DFVF_XYZRHW or D3DFVF_DIFFUSE or D3DFVF_SPECULAR or D3DFVF_TEX2
         );


/////////////////////////////
// CMotionInfo
//		mottype : motno ̐@B

type
  _motiontype = (
	 MOTIONTYPENONE,

	 MOTION_STOP, // motionno ŒB
	 MOTION_CLAMP, // motionno @maxɒBÂ܂܂ŌŒB
	 MOTION_ROUND, //		ŏɖ߂
	 MOTION_INV, //			tɐiށB

	 MOTIONTYPEMAX
	 );


{$ENDIF}

implementation

end.
