unit Unit1;

interface

uses Windows,SysUtils,Resource,D3DApp,Easy3D,Direct3D8,D3DX8,D3DFont,coef_v,MMSystem,Messages,Math;

const
    PHYSICALPOINTMAX=400;
    CAMERADIV=30;
    AFTERIMAGENUM=5;
    POSITIONMIN=		-4000.0;
    POSITIONMAX=		4000.0;

var
    s_KeyBuffer: TKeyboardState;
    s_MotStep: LongWord=0;
    s_starttime: LongWord=0;
    s_playmode: Integer=2;
    m_bDrawHelp: Integer;

    //s
    //ENDFLAG_NONE: Integer;
    //Motion_IDLE: Integer;
    //ID_KEY_ALL_RESET: Integer;

type
  E3DCookie = Record
	handlerid: Integer;
	motcookie: array[0..MOTION_MAX-1]of Integer;
	framemax: array[0..MOTION_MAX-1]of Integer;
    position: TD3DVECTOR;
    rotate: TD3DVECTOR;

	physicalpoint: Integer;
	motionid: Integer;
	frameno: Integer;
	defenseflag: Integer;
	setflag: Integer;

	afterimage: Integer;
    alpha: single;
  end;
  pE3DCookie = ^E3DCookie;

    CDmy3DApplication = class (CD3DApplication)
    private
	    m_d3dxsprite: ID3DXSPRITE;
        //m_indicator: CIndicator;

	    m_pFont: CD3DFont;
        m_pFontBig: CD3DFont;


        m_bKey: array[0..255]of Byte;
	    m_exit: Integer;
        m_drawtext: Integer;

        m_Girl1: E3DCOOKIE;
        m_Girl2: E3DCOOKIE;
        m_Ground: E3DCOOKIE;

        m_eye_y: single;
        m_rad: single;
        m_camdist: single;

        m_movestep: single;

        m_targetpos: TD3DVector;
        m_endCamerapos: TD3DVector;
        m_curCamerapos: TD3DVector;

        m_endflag: TEnum_Coef_v2;
        m_resttime: LongWord;

        m_projmode: _projmode;
        m_lightid: Integer;

        m_motion_initflag: Integer;
        m_soundid0: Integer;
        m_soundid1: Integer;
    protected
        function OneTimeSceneInit: HRESULT; override;
        function RestoreDeviceObjects: HRESULT; override;
        function InvalidateDeviceObjects: HRESULT; override;
        function DeleteDeviceObjects(): HRESULT; override;
        function Render: HRESULT; override;
        function FrameMove: HRESULT; override;
        function FinalCleanup: HRESULT; override;
        function InitDeviceObjects: HRESULT; override;

            procedure UpdateCamera;

	        function InitGameParams(): Integer;
            function LoadMotData(cookie: pE3DCookie; idlefile,kickfile,choppufile,upperfile,defensefile,deathfile,winfile: string): Integer;

            function SetResDir(): Integer;
	        function SetModuleDir(): Integer;
	        function MoveGirlXZ(cookie: pe3dcookie; keyid: Integer): Integer;

	        function DirToTheOtherXZ(e3d1,e3d2: pE3DCookie): Integer;
	        function SeparateFrom(e3d1,e3d2: pE3DCookie): Integer;
	        function CloseTo(e3d1,e3d2: pE3DCookie): Integer;

	        function ChangePhysicalPoint(): Integer;
	        function CheckTimeUp(): Integer;
	        function MoveCamera(): Integer;
	        function CheckOutOfRange(e3d: pE3DCookie): Integer;
            function UpdateGirlState(e3d1,e3d2: pE3DCookie;
		        keybuffer: TKeyBoardState;
		        confflag,
		        keykick, keychoppu, keydefense,
		        keyleft, keyright, keyup, keydown: Integer): Integer;

	        function AutoUpdateGirlState(e3d1,e3d2: pE3DCookie; confflag: Integer): Integer;

    public
        //function MsgProc(hWnd:HWND; uMsg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; override;

	    function ChangeMotionStep(): Integer;
	    function SetMotionStep(): Integer;

	    function SelectPlayMode(): Integer;

        constructor Create(hWindow: HWND);
        destructor Destroy; override;

    end;

//R[obNp
  function ChangeMotStepProc(hDlg: HWND; uiMsg: UINT; wParam: WPARAM; lParam: LPARAM): BOOL; cdecl;
  procedure UpdateDialogControls(hDlg: HWND; dwMotStep: DWORD); cdecl;

  function SelectPlayModeProc(hDlg: HWND; uiMsg: UINT; wParam: WPARAM; lParam: LPARAM): BOOL; cdecl;
  procedure UpdatePlayModeControls(hDlg: HWND); cdecl;

//Static
    var
        curStep: LongWord;


implementation

//R[obNp
function ChangeMotStepProc(hDlg: HWND; uiMsg: UINT; wParam: WPARAM; lParam: LPARAM): BOOL; cdecl;
var
    hwndMotStep: HWND;
    dwMotStep: LongWord; //?

begin
    // Handle the initialization message
    if( WM_INITDIALOG = uiMsg )
    then begin
		dwMotStep := s_MotStep;

        UpdateDialogControls( hDlg, dwMotStep );

        result:= TRUE;
        Exit;
    end
    else if( WM_COMMAND = uiMsg )
    then begin
        hwndMotStep  := GetDlgItem( hDlg, IDC_COMBO1 );

        // Get current UI state
{ TODO : GetCurSelDelphiłȂ }
        //dwMotStep := ComboBox_GetCurSel( hwndMotStep );
        dwMotStep := 0;

        if( IDOK = LOWORD(wParam) )
        then begin
            // Handle the case when the user hits the OK button. Check if any
            // of the options were changed
            if( dwMotStep <> s_MotStep )
            then begin
                // Return the newly selected device and its new properties

				s_MotStep := dwMotStep;

				//DbgOut( "CMyD3DApplication : ChangeMotStepProc : motstep changed to %d\n", s_MotStep );

                EndDialog( hDlg, IDOK );
            end
            else
                EndDialog( hDlg, IDCANCEL );

            result:= TRUE;
            Exit;
        end
        else if( IDCANCEL = LOWORD(wParam) )
        then begin
            // Handle the case when the user hits the Cancel button
            EndDialog( hDlg, IDCANCEL );
            result:= TRUE;
            Exit;
        end;

        // Keep the UI current
        UpdateDialogControls( hDlg, dwMotStep );
        result:= TRUE;
        Exit;
    end;

    result:= FALSE;
end;

procedure UpdateDialogControls(hDlg: HWND; dwMotStep: DWORD); cdecl;
var
    step,stepMax,dwItem: LongWord;
    hwndMotStep: HWND;
    //strstep()
begin
            { TODO : WindowsXDelphiɂ͂Ȃ }

	stepmax := 3;
	//char strstep[3][5] = { "1", "2", "3" };

    // Access to UI controls
    hwndMotStep         := GetDlgItem( hDlg, IDC_COMBO1 );

    // Reset the content in each of the combo boxes
    //ComboBox_ResetContent( hwndMotStep );

    // Add a list of devices to the device combo box
	for step:= 0 to stepmax-1
	do begin
        // Add device name to the combo box
        //dwItem := ComboBox_AddString( hwndMotStep, strstep[step] );

		if( dwMotStep = step )then begin

			// Set the combobox selection on the current device
		    //ComboBox_SetCurSel( hwndMotStep, dwItem );
		end;
	end;

end;

function SelectPlayModeProc(hDlg: HWND; uiMsg: UINT; wParam: WPARAM; lParam: LPARAM): BOOL; cdecl;
var
    check1, check2, check3: UINT;

begin
    // Handle the initialization message
    if( WM_INITDIALOG = uiMsg )
    then begin
        UpdatePlayModeControls( hDlg );
        result:= TRUE;
        Exit;
    end
    else if( WM_COMMAND = uiMsg )
    then begin

		check1 := IsDlgButtonChecked( hDlg, IDC_RADIO1 );
		check2 := IsDlgButtonChecked( hDlg, IDC_RADIO2 );
		check3 := IsDlgButtonChecked( hDlg, IDC_RADIO3 );
		if( check1 = BST_CHECKED )then
			s_playmode := 1
		else if( check2 = BST_CHECKED )then
			s_playmode := 2
		else if( check3 = BST_CHECKED )then
			s_playmode := 0;


		if( IDOK = LOWORD(wParam) ) then
			EndDialog( hDlg, IDOK );
		if( IDCANCEL = LOWORD(wParam) ) then
			EndDialog( hDlg, IDCANCEL );

        // Keep the UI current
        UpdatePlayModeControls( hDlg );
        result:= TRUE;
        Exit;
    end;

    result:= FALSE;
end;

procedure UpdatePlayModeControls(hDlg: HWND); cdecl;
begin
	case( s_playmode )of
	0:
		CheckRadioButton( hDlg, IDC_RADIO1, IDC_RADIO3, IDC_RADIO3 );
	1:
		CheckRadioButton( hDlg, IDC_RADIO1, IDC_RADIO3, IDC_RADIO1 );
	2:
		CheckRadioButton( hDlg, IDC_RADIO1, IDC_RADIO3, IDC_RADIO2 );
	else begin
		s_playmode := 2;
		CheckRadioButton( hDlg, IDC_RADIO1, IDC_RADIO3, IDC_RADIO2 );
    end;
	end;
end;


{ CDmy3DApplication }

function CDmy3DApplication.AutoUpdateGirlState(e3d1, e3d2: pE3DCookie;
  confflag: Integer): Integer;
var
    ret,outflag,factor0: Integer;
    factor1, factor2, factor3, factor4, factor5: Integer;
begin

	ret := 0;
	if( m_endflag = ENDFLAG_NONE )then begin
		outflag := CheckOutOfRange( e3d1 );
		if Boolean( outflag )then begin
			e3d1.motionid := e3d1.motcookie[MOTION_DEATH];
			e3d1.setflag := 1;
			e3d2.motionid := e3d2.motcookie[MOTION_WIN];
			e3d2.setflag := 1;
			m_endflag := ENDFLAG_OUTOFRANGE;
			if Boolean( e3d1.afterimage )then begin
				e3d1.afterimage := 0;
				ret := E3DDestroyAfterImage( e3d1.handlerid );
				if Boolean( ret )then begin
					ASSERT( Boolean(0) );
					result:= 1;
                    Exit;
				end;
			end;
			if Boolean( e3d2.afterimage )then begin
				e3d2.afterimage := 0;
				ret := E3DDestroyAfterImage( e3d2.handlerid );
				if Boolean( ret )then begin
					ASSERT( Boolean(0) );
					result:= 1;
                    Exit;
				end;
			end;

			e3d1.alpha := 1.0;
			e3d2.alpha := 1.0;
			E3DSetAlpha( e3d1.handlerid, e3d1.alpha );
			E3DSetAlpha( e3d2.handlerid, e3d2.alpha );

		end;
	end;

    if( m_endflag = ENDFLAG_NONE )then begin
		if( e3d1.motionid = e3d1.motcookie[MOTION_KICK] )then begin
			if( e3d1.frameno >= e3d1.framemax[MOTION_KICK] )then begin
				e3d1.motionid := e3d1.motcookie[MOTION_IDLE];
				e3d1.setflag := 1;
			end;
		end else if( e3d1.motionid = e3d1.motcookie[MOTION_PUNCH] )then begin
			if( e3d1.frameno >= e3d1.framemax[MOTION_PUNCH] )then begin
				e3d1.motionid := e3d1.motcookie[MOTION_IDLE];
				e3d1.setflag := 1;
			end;
		end else if( e3d1.motionid = e3d1.motcookie[MOTION_DEFENSE] )then begin
			if( e3d1.defenseflag < 20 )then begin
				inc(e3d1.defenseflag);
			end else begin
				e3d1.motionid := e3d1.motcookie[MOTION_IDLE];
				e3d1.setflag := 2;
				e3d1.defenseflag := 0;
			end;
		end else if( e3d1.motionid = e3d1.motcookie[MOTION_ACT1] )then begin
			if( e3d1.frameno >= e3d1.framemax[MOTION_ACT1] )then begin
				e3d1.motionid := e3d1.motcookie[MOTION_IDLE];
				e3d1.setflag := 1;

				if Boolean( e3d1.afterimage )then begin
					e3d1.afterimage := 0;
					ret := E3DDestroyAfterImage( e3d1.handlerid );
					if Boolean( ret )then begin
						ASSERT( Boolean(0) );
						result:= 1;
                        Exit;
					end;
				end;
				e3d1.alpha := 1.0;
				E3DSetAlpha( e3d1.handlerid, e3d1.alpha );

			end;
		end else begin
			if( confflag = 0 )then begin
				//int factor0;
				factor0 := random(500);
				if( (factor0 mod 5) =  0)then CloseTo( e3d1, e3d2 );
			end else begin
				//int factor1, factor2, factor3, factor4, factor5;
				factor1 := random(100);
				factor2 := random(100);
				factor3 := random(100);
				factor4 := random(100);
				factor5 := random(100);

				if( e3d2.motionid = e3d2.motcookie[MOTION_ACT1] )then begin
					e3d1.motionid := e3d1.motcookie[MOTION_DEFENSE];
					inc(e3d1.defenseflag);
					e3d1.setflag := 2;
				end else if( (factor1 mod 2) = 0 )then begin
					if( e3d1.motionid <> e3d1.motcookie[MOTION_IDLE] )then begin
						e3d1.motionid := e3d1.motcookie[MOTION_IDLE];
						e3d1.setflag := 2;
					end;
				end else begin
					if( (e3d2.motionid = e3d2.motcookie[MOTION_KICK]) or (e3d2.motionid = e3d2.motcookie[MOTION_PUNCH]) )then begin

						if( (factor2 mod 2) = 0 )then begin
							if( e3d1.motionid = e3d1.motcookie[MOTION_IDLE] )then begin
                                e3d1.motionid := e3d1.motcookie[MOTION_DEFENSE];
								inc(e3d1.defenseflag);
								e3d1.setflag:=2;
							end;
                        end else begin
							if( (factor3 mod 3) = 0 )then begin
								if( e3d1.motionid = e3d1.motcookie[MOTION_IDLE] )then begin
                                    e3d1.motionid := e3d1.motcookie[MOTION_KICK];
									e3d1.setflag := 2;
								end;
							end else if( (factor3 mod 3) = 2 )then begin
								if( e3d1.motionid = e3d1.motcookie[MOTION_IDLE] )then begin
                                    e3d1.motionid := e3d1.motcookie[MOTION_PUNCH];
									e3d1.setflag := 2;
								end;
							end else begin
								if (e3d1.motionid=e3d1.motcookie[MOTION_IDLE]) then begin
                                e3d1.motionid:=e3d1.motcookie[MOTION_ACT1];
                                    e3d1.setflag:=2;
                                    e3d1.afterimage := AFTERIMAGENUM;
									ret := E3DCreateAfterImage(e3d1.handlerid, m_pd3dDevice, e3d1.afterimage );
									if Boolean( ret )then begin
										ASSERT( Boolean(0) );
										result:= 1;
                                        exit;
									end;
									e3d1.alpha := 0.4;
									E3DSetAlpha( e3d1.handlerid,e3d1.alpha );
                                end
							end;
						end;
					end else begin
						if( (factor2 mod 2) = 0 )then begin
							if( e3d1.motionid = e3d1.motcookie[MOTION_IDLE] )then begin
                                e3d1.motionid := e3d1.motcookie[MOTION_KICK];
								e3d1.setflag := 2;
							end
						end else begin
							if( (factor3 mod 2) = 0 )then begin
								if( (factor4 mod 2) = 0 )then begin
									if( e3d1.motionid = e3d1.motcookie[MOTION_IDLE] )then begin
										e3d1.motionid := e3d1.motcookie[MOTION_PUNCH];
										e3d1.setflag := 2;
									end;
								end else begin
									if( (factor5 mod 2) = 0 )then begin
										if( e3d1.motionid = e3d1.motcookie[MOTION_IDLE] )then begin
                                            e3d1.motionid := e3d1.motcookie[MOTION_ACT1];
											e3d1.setflag := 2;
                                            e3d1.afterimage := AFTERIMAGENUM;
											ret := E3DCreateAfterImage( e3d1.handlerid, m_pd3dDevice, e3d1.afterimage );
                                            (*
											if( ret )then begin
                                                _ASSERT( 0 );
                                                return 1;
                                            end;*)
											e3d1.alpha := 0.4;
                                            E3DSetAlpha(e3d1.handlerid, e3d1.alpha );
                                        end;
									end else begin
										if( e3d1.motionid = e3d1.motcookie[MOTION_IDLE] )then begin
                                            e3d1.motionid := e3d1.motcookie[MOTION_PUNCH];
											e3d1.setflag := 2;
										end;
									end;
								end;
							end else begin
								if( e3d1.motionid = e3d1.motcookie[MOTION_IDLE] )then begin
                                    e3d1.motionid := e3d1.motcookie[MOTION_DEFENSE];
									inc(e3d1.defenseflag);
									e3d1.setflag:=2;
								end;
							end;
						end;
					end;

				end;
			end;
		end;

		if( (e3d1.motionid = e3d1.motcookie[MOTION_DEFENSE])and(e3d1.defenseflag = 0) )then begin
			e3d1.motionid := e3d1.motcookie[MOTION_IDLE];
			e3d1.setflag := 1;
		end;

		if Boolean( confflag )then begin
			if( (e3d1.motionid = e3d1.motcookie[MOTION_IDLE]) or (e3d1.motionid = e3d1.motcookie[MOTION_DEFENSE]) )then begin
				ret := SeparateFrom( e3d1, e3d2 );
                (*
				if( ret )then begin
					_ASSERT( 0 );
					return -1;
				end
                *)
			end;
		end;
	end;

	if( e3d1.setflag = 2 )then begin
		ret := DirToTheOtherXZ( e3d1, e3d2 );
        (*
		if( ret )then begin
			ASSERT( 0 );
			return -1;
		end
        *)
	end;

	if Boolean( e3d1.setflag )then begin
		ret := E3DSetMotionKind( e3d1.handlerid, e3d1.motionid );
		(*if( ret )then begin
			_ASSERT( 0 );
			return -1;
		end *)
	end;

	e3d1.frameno := E3DSetNewPause( e3d1.handlerid );
    (*
	if( e3d1.frameno < 0 )then begin
		//DbgOut( "CMyD3DApplication : FrameMove : SetNewPause error !!!\n" );
		_ASSERT( 0 );
		return -1;
	end
    *)

	result:= 0;
end;


function CDmy3DApplication.ChangeMotionStep: Integer;
var
    ret: Integer;
begin

	curstep := s_MotStep;
    if( IDOK = DialogBoxParam( HINSTANCE,
                                MAKEINTRESOURCE(IDD_CHANGEMOTSTEP),
                               GetForegroundWindow(),
                                @ChangeMotStepProc, 0 ) )then begin

		if( curstep <> s_MotStep )then begin
			ret := SetMotionStep();
			ASSERT( not Boolean(ret) );
		end;

        result:= S_OK;
        Exit;
	end;

    result:= -1;
end;

function CDmy3DApplication.ChangePhysicalPoint: Integer;
var
	ret : Integer;
	punch_damage1, kick_damage1, act1_damage1: Integer;
	punch_damage2, kick_damage2, act1_damage2: Integer;

begin
    ret:=0;

	if( m_girl1.motionid = m_girl1.motcookie[MOTION_DEFENSE] )then begin
		punch_damage1 := 1;
		kick_damage1 := 2;
		act1_damage1 := 4;
		//punch_damage1 = 0;
		//kick_damage1 = 0;

	end else begin
		punch_damage1 := 2;
		kick_damage1 := 4;
		act1_damage1 := 8;
	end;
	if( m_girl2.motionid = m_girl2.motcookie[MOTION_DEFENSE] )then begin
		punch_damage2 := 1;
		kick_damage2 := 2;
		act1_damage2 := 4;
		//punch_damage2 = 0;
		//kick_damage2 = 0;
	end else begin
		punch_damage2 := 2;
		kick_damage2 := 4;
		act1_damage2 := 8;
	end;

	if( m_girl1.motionid = m_girl1.motcookie[MOTION_PUNCH] )then
		m_girl2.physicalpoint := m_girl2.physicalpoint-punch_damage2
	else if( m_girl1.motionid = m_girl1.motcookie[MOTION_KICK] )then
		m_girl2.physicalpoint := m_girl2.physicalpoint-kick_damage2
	else if( m_girl1.motionid = m_girl1.motcookie[MOTION_ACT1] )then
		m_girl2.physicalpoint :=m_girl2.physicalpoint- act1_damage2;

	if( m_girl2.physicalpoint < 0 )then begin
		m_girl2.physicalpoint := 0;
	end;

	if( m_girl2.motionid = m_girl2.motcookie[MOTION_PUNCH] )then
		m_girl1.physicalpoint := m_girl1.physicalpoint -punch_damage1
	else if( m_girl2.motionid = m_girl2.motcookie[MOTION_KICK] )then
		m_girl1.physicalpoint := m_girl1.physicalpoint -kick_damage1
	else if( m_girl2.motionid = m_girl2.motcookie[MOTION_ACT1] )then
		m_girl1.physicalpoint := m_girl1.physicalpoint -act1_damage1;

	if( m_girl1.physicalpoint < 0 )then begin
		m_girl1.physicalpoint := 0;
	end;
	
	//I
	if( (m_girl1.physicalpoint = 0) and
		(m_girl1.motionid <> m_girl1.motcookie[MOTION_DEATH]) )then begin
		m_girl1.setflag := 1;
		m_girl1.motionid := m_girl1.motcookie[MOTION_DEATH];

		if( m_girl2.physicalpoint <> 0 )then begin
			m_girl2.setflag := 1;
			m_girl2.motionid := m_girl2.motcookie[MOTION_WIN];
		end;

		if Boolean( m_girl1.afterimage )then begin
			m_girl1.afterimage := 0;
			ret := E3DDestroyAfterImage( m_girl1.handlerid );
			if Boolean( ret )then begin
				ASSERT( Boolean(0) );
				Result:= 1;
                Exit;
			end;
		end;
		if Boolean( m_girl2.afterimage )then begin
			m_girl2.afterimage := 0;
			ret := E3DDestroyAfterImage( m_girl2.handlerid );
			if Boolean( ret )then begin
				ASSERT( Boolean(0) );
				Result:= 1;
                Exit;
			end;
		end;

		m_girl1.alpha := 1.0;
		m_girl2.alpha := 1.0;
		E3DSetAlpha( m_girl1.handlerid, m_girl1.alpha );
		E3DSetAlpha( m_girl2.handlerid, m_girl2.alpha );

		m_endflag := ENDFLAG_KO;
	end;

	if( (m_girl2.physicalpoint = 0) and
		(m_girl2.motionid <> m_girl2.motcookie[MOTION_DEATH]) )then begin
		m_girl2.setflag := 1;
		m_girl2.motionid := m_girl2.motcookie[MOTION_DEATH];

		if( m_girl1.physicalpoint <> 0 )then begin
			m_girl1.setflag := 1;
			m_girl1.motionid := m_girl1.motcookie[MOTION_WIN];
		end;

		if Boolean( m_girl1.afterimage )then begin
			m_girl1.afterimage := 0;
			ret := E3DDestroyAfterImage( m_girl1.handlerid );
			if Boolean( ret )then begin
				ASSERT( Boolean(0) );
				Result:= 1;
                Exit;
			end;
		end;

		if Boolean( m_girl2.afterimage )then begin
			m_girl2.afterimage := 0;
			ret := E3DDestroyAfterImage( m_girl2.handlerid );
			if Boolean( ret )then begin
				ASSERT( Boolean(0) );
				Result:= 1;
                Exit;
			end;
		end;

		m_girl1.alpha := 1.0;
		m_girl2.alpha := 1.0;
		E3DSetAlpha( m_girl1.handlerid, m_girl1.alpha );
		E3DSetAlpha( m_girl2.handlerid, m_girl2.alpha );

		m_endflag := ENDFLAG_KO;
	end;

	result:= 0;
end;

function CDmy3DApplication.CheckOutOfRange(e3d: pE3DCookie): Integer;
var
    outflag,ret: Integer;
    ccw,dot,rad,dot2: single;
    char2center, nchar2center, chardir,basevec: TD3DXVECTOR2;
begin
    outflag:=0;
	if( (e3d.position.x < POSITIONMIN) or
		(e3d.position.x > POSITIONMAX) or
		(e3d.position.z < POSITIONMIN) or
		(e3d.position.z > POSITIONMAX) )then begin

		outflag := 1;
	end;

	if Boolean( outflag )then begin
		//OɏoɁALN^[O̕Ăꍇɂ́A
		//ɌςĂMOTION_DEATHɂB([Vɓ|悤ɂȂĂ邽)
		chardir.x := -1.0 * sin( e3d.rotate.y );
		chardir.y := -1.0 * cos( e3d.rotate.y );

		char2center.x := (POSITIONMIN + POSITIONMAX) * 0.5 - e3d.position.x;
		char2center.y := (POSITIONMIN + POSITIONMAX) * 0.5 - e3d.position.z;

		D3DXVec2Normalize( nchar2center, char2center );

		dot := D3DXVec2Dot( chardir, nchar2center );
		if( dot < 0.0 )then begin

			basevec.x := 0.0;
			basevec.y := -1.0;

			dot2 := D3DXVec2Dot( basevec, nchar2center );
			if( dot2 > 1.0 )then
				dot2 := 1.0;
			if( dot2 < -1.0 )then
				dot2 := -1.0;
			rad := arccos( dot2 );

			ccw := D3DXVec2CCW( basevec, nchar2center );

			if( ccw >= 0.0 )then begin
				e3d.rotate.y := -rad;
			end else begin
				e3d.rotate.y := rad;
			end;
			ret := E3DSetRotate( e3d.handlerid, e3d.rotate );
			if Boolean( ret )then begin
				ASSERT( Boolean(0) );
				result:=1;
                Exit;
			end;
		end;

	end;

	result:= outflag;
end;

function CDmy3DApplication.CheckTimeUp: Integer;
var
    winner1,winner2,loser: E3DCOOKIE;
begin
	if( m_resttime > 0 )then begin
		result:= 0;
        Exit;
    end;

	if( (m_resttime = 0) and (m_endflag = ENDFLAG_NONE) )then begin
		if( m_girl1.physicalpoint > m_girl2.physicalpoint )then begin
			winner1 := m_girl1;
			winner2.handlerid:=-1;
			loser := m_girl2;
		end else if( m_girl1.physicalpoint < m_girl2.physicalpoint )then begin
			winner1 := m_girl2;
			winner2.handlerid:=-1;
			loser := m_girl1;
		end else begin
			winner1 := m_girl1;
			winner2 := m_girl2;
			loser .handlerid:=-1;
		end;

		m_endflag := ENDFLAG_TIMEUP;

		winner1.motionid := winner1.motcookie[MOTION_WIN];
		winner1.setflag := 1;
		if( winner2.handlerid<>-1 )then begin
			winner2.motionid := winner2.motcookie[MOTION_WIN];
			winner2.setflag := 1;
		end;
		if( loser.handlerid<>-1 )then begin
			loser.motionid := loser.motcookie[MOTION_IDLE];
			loser.setflag := 1;
		end;

	end;
	result:= 0;
end;

function CDmy3DApplication.CloseTo(e3d1, e3d2: pE3DCookie): Integer;
var
    ret: Integer;
    vec,nvec: TD3DXVECTOR2;
begin
	vec.x := e3d2.position.x - e3d1.position.x;
	vec.y := e3d2.position.z - e3d1.position.z;

	D3DXVec2Normalize( nvec, vec );
	e3d1.position.x := e3d1.position.x + m_movestep * nvec.x;
	e3d1.position.z := e3d1.position.z + m_movestep * nvec.y;

	ret := E3DSetPosition( e3d1.handlerid, e3d1.position );
	if Boolean( ret )then begin
		ASSERT( Boolean(0) );
		result:= 1;
        Exit;
	end;

	ret := DirToTheOtherXZ( e3d1, e3d2 );
	if Boolean( ret )then begin
		ASSERT( Boolean(0) );
		result:= 1;
        Exit;
	end;

	result:= 0;


end;

constructor CDmy3DApplication.Create(hWindow: HWND);
var
    mno: Integer; tmp: String;
begin
  inherited;
	m_d3dxsprite := nil;
	//m_indicator := 0;

    tmp:='Viewer3  ';
    m_strWindowTitle    := pChar(tmp);

    m_bUseDepthBuffer   := TRUE;

    m_pFont := CD3DFont.Create( 'Arial', 12, D3DFONT_BOLD );
    m_pFontBig := CD3DFont.Create( 'Arial',  36, D3DFONT_BOLD );

    ZeroMemory( @m_bKey[0], 256 );
	m_exit := 0;
	m_drawtext := 0;

	m_girl1.handlerid := -1;
	m_girl2.handlerid := -1;
	m_girl1.motionid := -1;
	m_girl2.motionid := -1;
	m_ground.handlerid := -1;
	for  mno:=0 to MOTION_MAX-1 do begin
		m_girl1.motcookie[mno] := -1;
		m_girl1.framemax[mno] := 0;

		m_girl2.motcookie[mno] := -1;
		m_girl2.framemax[mno] := 0;

		m_ground.motcookie[mno] := -1;
		m_ground.framemax[mno] := 0;
	end;

	InitGameParams();


	m_projmode := PROJ_NORMAL;

	m_lightid := -1;

	m_motion_initflag := 0;
end;

function CDmy3DApplication.DeleteDeviceObjects: HRESULT;
begin
    m_pFont.DeleteDeviceObjects();
    m_pFontBig.DeleteDeviceObjects();

    result:= S_OK;
end;

destructor CDmy3DApplication.Destroy;
begin

  inherited;
end;

function CDmy3DApplication.DirToTheOtherXZ(e3d1, e3d2: pE3DCookie): Integer;
var
    ret: Integer;
    vec,nvec,basevec: TD3DXVECTOR2;
    dot,rad,ccw,roty: single;
begin
	basevec.x := 0.0;
	basevec.y := -1.0;

	vec.x := e3d2.position.x - e3d1.position.x;
	vec.y := e3d2.position.z - e3d1.position.z;

	D3DXVec2Normalize( nvec, vec );
	dot := D3DXVec2Dot( basevec, nvec );
	if( dot <= -1.0 ) then
		dot := -1.0
	else if( dot >= 1.0 ) then
		dot := 1.0;

	rad := arccos( dot );
	ccw := D3DXVec2CCW( basevec, nvec );

	if( ccw >= 0.0 )then begin
		roty := -rad;
	end else begin
		roty := rad;
	end;

	e3d1.rotate.y := roty;
    ret := 0;
	ret := E3DSetRotate( e3d1.handlerid, e3d1.rotate );
	if Boolean( ret )then begin
        ASSERT( Boolean(0) );
		result:= 1;
        Exit;
	end;
	result:= 0;
end;

function CDmy3DApplication.FinalCleanup: HRESULT;
begin
    //SAFE_DELETE( m_pFont );
    //SAFE_DELETE( m_pFontBig );
    m_pFont.Free;
    m_pFontBig.Free;

	E3DDestroyHandler( m_girl1.handlerid );
	E3DDestroyHandler( m_girl2.handlerid );
	E3DDestroyHandler( m_ground.handlerid );

	(*if( m_indicator ){
		delete m_indicator;
		m_indicator = 0;
	} *)

	E3DDestroyLight( m_lightid, m_pd3dDevice );

	E3DBye( 1 );

	//CloseDbgFile();

    result:= S_OK;
end;

//Statiĉ̓[JŐ錾_Ȃ񂾂낤ȂEEE
var
    callcnt: Integer=0;
    confflag,drawtextflag,projflag: Integer;
    scale: single=1.0;

function CDmy3DApplication.FrameMove: HRESULT;
var
    ret,ShiftP,ShiftD,inviewflag: Integer;
    curtime, difftime: LongWord;
    vUpVec,rate1,rate2,scalevec: TD3DVector;
    matView: TD3DXMatrix;
    testPart,r,g,b: Integer;
begin
	ret := 0;

	GetKeyboardState( s_KeyBuffer );

	if Boolean(s_KeyBuffer[ord('Q')] and $80)then begin
		ChangeMotionStep();
	end;

	//shift+PL[ĕƂm_projmodeXVB
	shiftP := 0;
	if Boolean( (s_KeyBuffer[VK_SHIFT] and $80) and (s_KeyBuffer[ord('P')] and $80) )then begin
		shiftP := 1;
	end;
	if( (projflag = 1) and (shiftP = 0) )then begin
		if( m_projmode = PROJ_NORMAL )then
			m_projmode := PROJ_LENS
		else
			m_projmode := PROJ_NORMAL;
	end;
	projflag := shiftP;
	

	//shift+DL[ĕƂm_drawtextXVB
	shiftD := 0;
	if Boolean( (s_KeyBuffer[VK_SHIFT] and $80) and (s_KeyBuffer[ord('D')] and $80) )then begin
		shiftD := 1;
	end;
	if Boolean( (drawtextflag = 1) and (shiftD = 0) )then begin
		if Boolean( m_drawtext )then
			m_drawtext := 0
		else
			m_drawtext := 1;
	end;

	drawtextflag := shiftD;


	m_girl1.setflag := 0;
	m_girl2.setflag := 0;

	if( callcnt = 0 )then
		s_starttime := timeGetTime();

	if Boolean( (s_KeyBuffer[VK_SHIFT] and $80) and (s_KeyBuffer[ord('R')] and $80) )then begin
		if Boolean( m_girl1.afterimage )then begin
			E3DDestroyAfterImage( m_girl1.handlerid );
			m_girl1.afterimage := 0;
		end;
		if Boolean( m_girl2.afterimage )then begin
			E3DDestroyAfterImage( m_girl2.handlerid );
			m_girl2.afterimage := 0;
		end;

		InitGameParams();

		E3DSetAlpha( m_girl1.handlerid, m_girl1.alpha );
		E3DSetAlpha( m_girl2.handlerid, m_girl2.alpha );

		confflag := 0;
		MoveGirlXZ( @m_girl1, ID_KEY_ALL_RESET );
		MoveGirlXZ( @m_girl2, ID_KEY_ALL_RESET );
		
		if( m_bWindowed )then begin
			ret := SelectPlayMode();
			if Boolean( ret )then begin
				ASSERT( Boolean(0) );
				Result:= -1;
                Exit;
			end;
		end;
		s_starttime := timeGetTime();
	end;

	curtime := timeGetTime();
	difftime := curtime - s_starttime;
	m_resttime := FIGHTINGTIME - difftime div 1000;
	ret := CheckTimeUp();
        if Boolean( ret )then begin
            ASSERT( Boolean(0) );
            Result:= -1;
            Exit;
        end;

	if Boolean( confflag )then begin
		ret := ChangePhysicalPoint();
        if Boolean( ret )then begin
            ASSERT( Boolean(0) );
            Result:= -1;
            Exit;
        end;
	end;

	if( s_playmode >= 1 )then begin
		UpdateGirlState( @m_girl1, @m_girl2,
			s_KeyBuffer,
			confflag,
			ord('B'), ord('N'), ord('M'),
			VK_LEFT, VK_RIGHT, VK_UP, VK_DOWN );
	end else begin
		AutoUpdateGirlState( @m_girl1, @m_girl2, confflag );
	end;

	if( s_playmode = 2 )then begin
		UpdateGirlState( @m_girl2, @m_girl1,
			s_KeyBuffer,
			confflag,
			ord('X'), ord('C'), ord('Z'),
			ord('F'), ord('G'), ord('T'), ord('V') );
	end else begin
		AutoUpdateGirlState( @m_girl2, @m_girl1, confflag );
	end;

	ret := MoveCamera();
        if Boolean( ret )then begin
            ASSERT( Boolean(0) );
            Result:= -1;
            Exit;
        end;

    // Rotate the camera about the y-axis
    vUpVec    := D3DXVECTOR3( 0.0, 1.0, 0.0 );

    // Set the app view matrix for normal viewing
	D3DXMatrixLookAtLH( matView, m_curCamerapos, m_targetpos, vUpVec );


	ret := E3DChkInView( m_girl1.handlerid, m_curCamerapos, m_targetpos );
        if Boolean( ret )then begin
            ASSERT( Boolean(0) );
            Result:= -1;
            Exit;
        end;

	ret := E3DChkInView( m_girl2.handlerid, m_curCamerapos, m_targetpos );
        if Boolean( ret )then begin
            ASSERT( Boolean(0) );
            Result:= -1;
            Exit;
        end;

	ret := E3DChkInView( m_ground.handlerid, m_curCamerapos, m_targetpos );
        if Boolean( ret )then begin
            ASSERT( Boolean(0) );
            Result:= -1;
            Exit;
        end;


	ret := E3DTransform( m_girl1.handlerid, m_pd3dDevice, matView, m_girl1.frameno, 1, Integer(m_projmode) );
        if Boolean( ret )then begin
            ASSERT( Boolean(0) );
            Result:= -1;
            Exit;
        end;

	ret := E3DTransform( m_girl2.handlerid, m_pd3dDevice, matView, m_girl2.frameno, 1, Integer(m_projmode) );
        if Boolean( ret )then begin
            ASSERT( Boolean(0) );
            Result:= -1;
            Exit;
        end;

	ret := E3DTransform( m_ground.handlerid, m_pd3dDevice, matView, m_ground.frameno, 1, Integer(m_projmode) );
        if Boolean( ret )then begin
            ASSERT( Boolean(0) );
            Result:= -1;
            Exit;
        end;

	rate1:=D3DXVECTOR3( 1.0, 1.0, 1.0 );
    rate2:=D3DXVECTOR3( 1.0, 1.0, 1.0 );
	confflag := E3DChkConflict( m_girl1.handlerid, m_girl2.handlerid, rate1, rate2, inviewflag );
	if( confflag < 0 )then begin
            ASSERT( Boolean(0) );
            Result:= -1;
            Exit;
	end;
	if( inviewflag > 0 )then begin
		//OɃIuWFNgꍇ́AE3DChkConflict́AɗȂ̂ŁÅ֐gpBIII
		E3DChkConfBySphere( m_girl1.handlerid, m_girl2.handlerid, 2, confflag );
	end;


	if ( Boolean(s_KeyBuffer[VK_SHIFT] and $80) and Boolean(s_KeyBuffer[ord('S')] and $80) and ((callcnt mod 5) = 0) )then begin
		if( m_soundid1 >= 0 )then begin
            { TODO : EEE }
			//E3DPlaySound( m_soundid1, 0 );
		end;
	end;


	//E3DSetScalẽeXg
    {
	E3DGetPartNoByName( m_girl1.handlerid, 'XJ[g', testpart );

	if Boolean( (s_KeyBuffer[VK_SHIFT] and $80) and (s_KeyBuffer[ord('1')] and $80) )then begin
		scale := scale-0.01;
		if( scale < 0.0 )then
			scale := 0.0;
		scalevec.x := scale;
		scalevec.y := scale;
		scalevec.z := scale;
		E3DSetScale( m_girl1.handlerid, -1, scalevec, 0 );
	end;
	if Boolean( (s_KeyBuffer[VK_SHIFT] and $80) and (s_KeyBuffer[ord('2')] and $80) )then begin
		scale := scale+0.01;
		if( scale > 2.0 )then
			scale := 2.0;
		scalevec.x := scale;
		scalevec.y := scale;
		scalevec.z := scale;
		E3DSetScale( m_girl1.handlerid, -1, scalevec, 0 );
	end;

	//E3DSetRenderStatẽeXg

	if Boolean( (s_KeyBuffer[VK_SHIFT] and $80) and (s_KeyBuffer[ord('1')] and $80) )then begin
		E3DSetRenderState( m_girl1.handlerid, testpart, Integer(D3DRS_FILLMODE), 1 );
	end;
	if Boolean( (s_KeyBuffer[VK_SHIFT] and $80) and (s_KeyBuffer[ord('2')] and $80) )then begin
		E3DSetRenderState( m_girl1.handlerid, testpart, Integer(D3DRS_FILLMODE), 2 );
	end;
	if Boolean( (s_KeyBuffer[VK_SHIFT] and $80) and (s_KeyBuffer[ord('3')] and $80) )then begin
		E3DSetRenderState( m_girl1.handlerid, testpart, Integer(D3DRS_FILLMODE), 3 );
	end;

	//E3DSetBlendingModẽeXg

	if Boolean( (s_KeyBuffer[VK_SHIFT] and $80) and (s_KeyBuffer[ord('1')] and $80) )then begin
		E3DSetBlendingMode( m_girl1.handlerid, testpart, 0 );
	end;
	if Boolean( (s_KeyBuffer[VK_SHIFT] and $80) and (s_KeyBuffer[ord('2')] and $80) )then begin
		E3DSetBlendingMode( m_girl1.handlerid, testpart, 1 );
	end;

	//E3DSetDiffuse, E3DSetSpecular, E3DSetAmbient̃eXg

	{r := 255;
	g := 255;
	b := 255;

	if Boolean( (s_KeyBuffer[VK_SHIFT] and $80) and (s_KeyBuffer[ord('1')] and $80) )then begin
		r := r-5;
		if( r < 0 )then
			r := 0;
		E3DSetDiffuse( m_girl1.handlerid, testpart, r, g, b, 0 );
	end;
	if Boolean( (s_KeyBuffer[VK_SHIFT] and $80) and (s_KeyBuffer[ord('2')] and $80) )then begin
		r := r+5;
		if( r > 255 )then
			r := 255;
		E3DSetDiffuse( m_girl1.handlerid, testpart, r, g, b, 0 );
	end;

	if Boolean( (s_KeyBuffer[VK_SHIFT] and $80) and (s_KeyBuffer[ord('3')] and $80) )then begin
		r :=r- 5;
		if( r < 0 )then
			r := 0;
		E3DSetSpecular( m_girl1.handlerid, -1, r, g, b, 0 );
	end;
	if( (s_KeyBuffer[VK_SHIFT] and $80) and (s_KeyBuffer[ord('4')] and $80) )then
		r += 5;
		if( r > 255 )
			r = 255;
		E3DSetSpecular( m_girl1.handlerid, -1, r, g, b, 0 );
	end;

	if( (s_KeyBuffer[VK_SHIFT] & 0x80) && (s_KeyBuffer['5'] & 0x80) )then begin
		r -= 5;
		if( r < 0 )
			r = 0;
		E3DSetAmbient( m_girl1.handlerid, -1, r, g, b, 0 );
	end;
	if( (s_KeyBuffer[VK_SHIFT] & 0x80) && (s_KeyBuffer['6'] & 0x80) )then begin
		r += 5;
		if( r > 255 )
			r = 255;
		E3DSetAmbient( m_girl1.handlerid, -1, r, g, b, 0 );
	end;
    }

	//E3DSetValidFlag̃eXg

	{if( (s_KeyBuffer[VK_SHIFT] & 0x80) && (s_KeyBuffer['1'] & 0x80) )then begin
		E3DSetValidFlag( m_girl1.handlerid, testpart, 0 );
	end;

	if( (s_KeyBuffer[VK_SHIFT] & 0x80) && (s_KeyBuffer['2'] & 0x80) )then begin
		E3DSetValidFlag( m_girl1.handlerid, testpart, 1 );
	end;

	//E3DSetAlpha2 ̃eXg

	if( (s_KeyBuffer[VK_SHIFT] & 0x80) && (s_KeyBuffer['1'] & 0x80) )then begin
		m_girl1.alpha -= 0.05f;
		if( m_girl1.alpha < 0.0f )then
			m_girl1.alpha = 0.0f;
		E3DSetAlpha2( m_girl1.handlerid, m_girl1.alpha, testpart );
	end;

	if( (s_KeyBuffer[VK_SHIFT] & 0x80) && (s_KeyBuffer['2'] & 0x80) )then begin
		m_girl1.alpha += 0.05f;
		if( m_girl1.alpha > 1.0f )then begin
			m_girl1.alpha = 1.0f;
		end;
		E3DSetAlpha2( m_girl1.handlerid, m_girl1.alpha, testpart );
	end;}

	inc(callcnt);


    Result:= S_OK;
    Exit;
end;

function CDmy3DApplication.InitDeviceObjects: HRESULT;
begin
    m_pFont.InitDeviceObjects( m_pd3dDevice );
    m_pFontBig.InitDeviceObjects( m_pd3dDevice );

	result:= S_OK;
end;

function CDmy3DApplication.InitGameParams: Integer;
begin
	m_girl1.motionid := m_girl1.motcookie[MOTION_IDLE];
	m_girl2.motionid := m_girl2.motcookie[MOTION_IDLE];

	m_girl1.position.x := 1000.0;
	m_girl1.position.y := 0.0;
	m_girl1.position.z := 0.0;
	m_girl1.rotate.x := 0.0;
	m_girl1.rotate.y := PI / 2.0;
	//m_girl1.rotate.y := 0.0;
	m_girl1.rotate.z := 0.0;
	m_girl1.physicalpoint := PHYSICALPOINTMAX;
	m_girl1.frameno := 0;
	m_girl1.defenseflag := 0;
	m_girl1.setflag := 1;
	m_girl1.afterimage := 0;
	m_girl1.alpha := 1.0;

	m_girl2.position.x := -1000.0;
	m_girl2.position.y := 0.0;
	m_girl2.position.z := 0.0;
	m_girl2.rotate.x := 0.0;
    m_girl2.rotate.y := PI / -2.0;
	//m_girl2.rotate.y := 0.0;
	m_girl2.rotate.z := 0.0;
	m_girl2.physicalpoint := PHYSICALPOINTMAX;
	m_girl2.frameno := 0;
	m_girl2.defenseflag := 0;
	m_girl2.setflag := 1;
	m_girl2.afterimage := 0;
	m_girl2.alpha := 1.0;

	m_rad := 0.0;
	m_eye_y := 2500.0;
	//m_eye_y = 1500.0f;
	m_camdist := 4200.0;

	m_movestep := 100.0;

	m_targetpos.x := 0.0;
	m_targetpos.y := 0.0;
	m_targetpos.z := 0.0;
	m_endCamerapos.x := 0.0;
	m_endCamerapos.y := 0.0;
	m_endCamerapos.z := 0.0;
	m_curCamerapos.x := 0.0;
	m_curCamerapos.y := 0.0;
	m_curCamerapos.z := 0.0;

	m_endflag := ENDFLAG_NONE;

	Result:=0;
end;

function CDmy3DApplication.InvalidateDeviceObjects: HRESULT;
var
    ret: Integer;
begin
    m_pFont.InitDeviceObjects( m_pd3dDevice );
    m_pFontBig.InitDeviceObjects( m_pd3dDevice );

	if( m_d3dxsprite <> Nil )then begin
		m_d3dxsprite._Release;
		m_d3dxsprite := Nil;
	end;

	(*ret = m_indicator.InvalidatePhysicalBar();
	if( ret ){
		_ASSERT( 0 );
		return -1;
	} *)

    m_pFont.InvalidateDeviceObjects();
    m_pFontBig.InvalidateDeviceObjects();

	ret := E3DInvalidate( m_girl1.handlerid );

	ret := E3DInvalidate( m_girl2.handlerid );

	ret := E3DInvalidate( m_ground.handlerid );

	if Boolean( m_girl1.afterimage )then begin
		ret := E3DDestroyAfterImage( m_girl1.handlerid );
		(*if( ret ){
			_ASSERT( 0 );
			return -1;
		} *)
	end;

	if Boolean( m_girl2.afterimage )then begin
		ret := E3DDestroyAfterImage( m_girl2.handlerid );
		(* if( ret ){
			_ASSERT( 0 );
			return -1;
		}  *)
	end;

    result:=S_OK;
end;

function CDmy3DApplication.LoadMotData(cookie: pE3DCookie; idlefile,
  kickfile, choppufile, upperfile, defensefile, deathfile,
  winfile: string): Integer;
var
    ret: Integer;

    procedure Sub(fname: string; index: Integer);
    begin
        //mot:=(cookie.motcookie[MOTION_IDLE]);
        //frm:=(cookie.framemax[MOTION_IDLE]);
	    ret := E3DAddMotion( cookie.handlerid,pChar(ExtractFilePath(ParamStr(0))+fName),cookie.motcookie[Index],cookie.framemax[INDEX]);
        ret:=0;
        //cookie.motcookie[MOTION_IDLE]:=mot;
        //cookie.framemax[MOTION_IDLE]:=frm;

    end;

begin
	ret := 0;

    Sub(idlefile,MOTION_IDLE);
	if boolean( ret )then begin
		ASSERT( False );
		result:= 1;
        Exit;
	end;

    Sub(kickfile,MOTION_KICK);
	if boolean( ret )then begin
		ASSERT( False );
		result:= 1;
        Exit;
	end;

    Sub(choppufile,MOTION_PUNCH);
	if boolean( ret )then begin
		ASSERT( False );
		result:= 1;
        Exit;
	end;

    Sub(upperfile,MOTION_ACT1);
	if boolean( ret )then begin
		ASSERT( False );
		result:= 1;
        Exit;
	end;

    Sub(defensefile,MOTION_Defense);
	if boolean( ret )then begin
		ASSERT( False );
		result:= 1;
        Exit;
	end;

    Sub(deathfile,MOTION_DEATH);
	if boolean( ret )then begin
		ASSERT( False );
		result:= 1;
        Exit;
	end;

    Sub(winfile,MOTION_WIN);
	if boolean( ret )then begin
		ASSERT( False );
		result:= 1;
        Exit;
	end;

	Result:=0;
end;

function CDmy3DApplication.MoveCamera: Integer;
var
    distdeath,posy,length,dist: single;
    pos1, pos2,char2char,upvec,cameravec,ncameravec,start2end: TD3DVector;

begin
	distdeath := 2000.0;

	posy := m_eye_y;

	if( m_girl1.motionid <> m_girl1.motcookie[MOTION_DEATH] )then begin
		pos1 := m_girl1.position;
		posy := m_eye_y * 0.5;
	end else begin
		pos1.x := m_girl1.position.x + distdeath * sin( m_girl1.rotate.y );
		pos1.y := m_girl1.position.y;
		pos1.z := m_girl1.position.z + distdeath * cos( m_girl1.rotate.y );
	end;

	if(m_girl2.motionid <> m_girl2.motcookie[MOTION_DEATH])then begin
		pos2 := m_girl2.position;
		posy := m_eye_y * 0.5;
	end else begin
		pos2.x := m_girl2.position.x + distdeath * sin( m_girl2.rotate.y );
		pos2.y := m_girl2.position.y;
		pos2.z := m_girl2.position.z + distdeath * cos( m_girl2.rotate.y );
	end;

	m_targetpos.x := (pos1.x + pos2.x) * 0.5;
	m_targetpos.y := posy;
	m_targetpos.z := (pos1.z + pos2.z) * 0.5;

	char2char.x := pos2.x - pos1.x;
	char2char.y := pos2.y - pos1.y;
	char2char.z := pos2.z - pos1.z;

	length := D3DXVec3Length( char2char );

	upvec.x := 0.0;
	upvec.y := 1.0;
	upvec.z := 0.0;

	D3DXVec3Cross( cameravec, char2char, upvec );

	D3DXVec3Normalize( ncameravec, cameravec );

	dist := length * 2.0;
	if( dist < m_camdist )then
		dist := m_camdist;

	m_endCamerapos.x := m_targetpos.x + dist * ncameravec.x;
	m_endCamerapos.y := m_targetpos.y;
	m_endCamerapos.z := m_targetpos.z + dist * ncameravec.z;

	start2end.x := m_endCamerapos.x - m_curCamerapos.x;
	start2end.y := m_endCamerapos.y;
	start2end.z := m_endCamerapos.z - m_curCamerapos.z;

	m_curCamerapos.x := m_curCamerapos.x+ start2end.x / CAMERADIV;
	m_curCamerapos.y := start2end.y;
	m_curCamerapos.z := m_curCamerapos.z+ start2end.z / CAMERADIV;

	(***
	m_endCamerapos.x = m_girl1.position.x;
	m_endCamerapos.y = 900.0f;
	m_endCamerapos.z = m_girl1.position.z;

	m_targetpos = m_endCamerapos;

	float cosy, siny;
	cosy = (float)cos( m_girl1.rotate.y );
	siny = (float)sin( m_girl1.rotate.y );

	m_curCamerapos.x = m_girl1.position.x + 3000.0f * siny;
	m_curCamerapos.y = 900.0f;
	m_curCamerapos.z = m_girl1.position.z + 3000.0f * cosy;
	***)

	result:= 0;
end;

function CDmy3DApplication.MoveGirlXZ(cookie: pe3dcookie;
  keyid: Integer): Integer;
var
    setrot,setpos,ret: Integer;
    cosy, siny: single;
begin
	case( keyid )of
	ID_KEY_LEFT: begin
		cookie.rotate.y := cookie.rotate.y -0.1;
		setrot := 1;
    end;
	ID_KEY_RIGHT: begin
		cookie.rotate.y := cookie.rotate.y +0.1;
		setrot := 1;
    end;
	ID_KEY_UP: begin
		cosy := m_movestep * cos( cookie.rotate.y );
		siny := m_movestep * sin( cookie.rotate.y );
		cookie.position.x := cookie.position.x -siny;
		cookie.position.z := cookie.position.z -cosy;
		setpos := 1;
    end;
	ID_KEY_DOWN: begin
		cosy := m_movestep * cos( cookie.rotate.y );
		siny := m_movestep * sin( cookie.rotate.y );
		cookie.position.x := cookie.position.x +siny;
		cookie.position.z := cookie.position.z +cosy;
		setpos := 1;
    end;
	ID_KEY_ALL_RESET: begin
		setpos := 1;
		setrot := 1;
    end;
	end;

	ret := 0;
	if Boolean( setrot )then begin
		ret := E3DSetRotate( cookie.handlerid, cookie.rotate );
		if Boolean( ret )then begin
			ASSERT( Boolean(0) );
			result:= 1;
            exit;
		end;
	end;

	if Boolean( setpos )then begin
		ret := E3DSetPosition( cookie.handlerid, cookie.position );
		if Boolean( ret )then begin
			ASSERT( Boolean(0) );
			result:= 1;
            exit;
		end;
	end;

	result:= 0;
end;

{function CDmy3DApplication.MsgProc(hWnd: HWND; uMsg: UINT; wParam: WPARAM;
  lParam: LPARAM): LRESULT;
begin

	if( uMsg = WM_COMMAND )then begin
		if( LOWORD( wParam ) = IDM_EXIT )then begin
			//IDM_EXIT̓ANZ[^VK_ESCAPE`B
			m_exit := 1;
			//DbgOut( "keydown vk_escape\n" );
			//DXTrace( "viewer3.cpp", 660, 0, "keydown vk_escape\n", FALSE );
		end;
	end;


	(*
    // Record key presses
    if( WM_KEYDOWN == uMsg )
    {
        m_bKey[wParam] = 1;
    }

    // Perform commands when keys are rleased
    {if( WM_KEYUP == uMsg )

        m_bKey[wParam] = 0;

        switch( wParam )
        {
            case VK_F1:
                m_bDrawHelp = !m_bDrawHelp;
                return 1;

            case 'R':
                if( m_bCanDoAlphaBlend )
                    m_bDrawReflection = !m_bDrawReflection;
                break;

            case VK_F3:
                m_bAnimateEmitter = !m_bAnimateEmitter;
                break;

            case VK_F4:
                if( ++m_dwParticleColor >= NUM_COLORS )
                    m_dwParticleColor = COLOR_WHITE;
                break;
        end;
    end;
	*)

    inherited MsgProc(hwnd,uMsg,wParam,lParam);

end; }

function CDmy3DApplication.OneTimeSceneInit: HRESULT;
var
    ret,resdirleng: Integer;
	resdirname,soundname0,soundname1: String;

begin
	ret:=E3DInit( 0, Hinstance, 1 );

	//ret := SetModuleDir();
	{if Boolean( ret )then begin
		result:= -1;
        Exit;
    end;}
	//ret := SetResDir();
	{if Boolean( ret )then begin
		result:= -1;
        Exit;
    end;}

    E3DSetProjection( 100.0, 10000.0, 45.0 );


	m_girl1.handlerid := E3DCreateHandler( 'ni_parts_4_bone.sig' );

	m_girl2.handlerid := E3DCreateHandler( 'na_parts_1_bone.sig' );
	ret := MoveGirlXZ( @m_girl1, ID_KEY_ALL_RESET );
	ret := MoveGirlXZ( @m_girl2, ID_KEY_ALL_RESET );

	//m_ground.handlerid = E3DCreateHandler( 'groundplane1_p.sig' );

	m_ground.handlerid := E3DCreateHandler( 'whiteplane.sig' );

	E3DSetPosition( m_ground.handlerid, D3DXVECTOR3(0,0,0));

	//ret := SelectPlayMode();

	E3DCreateLight( m_lightid );

	// Cg̃ZbǵAm_pd3dDeviceɒlZbgĂIIIiRestoreDeviceObjectsj

    { TODO : Ȃ񂩂̂ }
    
	//resdirname[0] = 0;
	//resdirname := GetEnvironmentVariable('RESDIR');

	//_ASSERT( resdirleng );

	//char soundname0[1024];
	//char soundname1[1024];

	//strcpy( soundname0, resdirname );
	//strcat( soundname0, 'canyon.mid' );


	//strcpy( soundname1, resdirname );
	//strcat( soundname1, 'sbounce.wav' );

	//m_soundid0 = E3DLoadSound( soundname0 );
	//_ASSERT( m_soundid0 >= 0 );

	//m_soundid1 = E3DLoadSound( soundname1 );
	//_ASSERT( m_soundid1 >= 0 );


	//srand( (unsigned)time( NULL ) );


    Result:=S_OK;
end;

function CDmy3DApplication.Render: HRESULT;
var
    ret: Integer; hr: HRESULT;
begin
	if Boolean( m_exit ) then begin
		result:= S_OK;Exit;
    end;

    if( FAILED( m_pd3dDevice.BeginScene() ) ) then begin
        result:= S_OK;Exit;
    end;

    // Clear the viewport
    m_pd3dDevice.Clear( 0, nil, D3DCLEAR_TARGET or D3DCLEAR_ZBUFFER,
                         $000000ff,
						 //0x00ffffff,
						 1.0, 0 );

    //E3DChkinView(m_girl1.handlerid,


	//sIuWFNg̕`
	ret := E3DRender( m_girl1.handlerid, m_pd3dDevice, 0 );
	ret := E3DRender( m_girl2.handlerid, m_pd3dDevice, 0 );
	ret := E3DRender( m_ground.handlerid, m_pd3dDevice, 0 );

	//IuWFNg̕`
	ret := E3DRender( m_girl1.handlerid, m_pd3dDevice, 1 );
	ret := E3DRender( m_girl2.handlerid, m_pd3dDevice, 1 );

	// sprite
	hr := m_d3dxsprite._Begin;

	hr := m_d3dxsprite._End();

	if boolean( m_drawtext )then begin
		// Output statistics
		m_pFont.m_fTextScale := 1.0;
		m_pFont.DrawText( 2,  0, D3DCOLOR_ARGB(255,255,255,0), m_strFrameStats );
		m_pFont.DrawText( 2, 20, D3DCOLOR_ARGB(255,255,255,0), m_strDeviceStats );
	end;

    // Draw help
    {
    if Boolean( m_bDrawHelp )then begin
        m_pFontBig.DrawText( 2, 40, $ffffffff,
                                ('Keyboard controls:') );
        {m_pFontBig.DrawText( 20, 60, $ffffffff,
                                _T("Move\nTurn\nPitch\nSlide\n\nHelp\n"
                                   "Change device\nAnimate emitter\n"
                                   "Change color\n\nToggle reflection\n"
                                   "Exit") );
        {m_pFontBig.DrawText( 160, 60, $ffffffff,
                                _T("W,S\nE,Q\nA,Z\nArrow keys\n\n"
                                   "F1\nF2\nF3\nF4\n\nR\nEsc") );

    end
    else begin
        m_pFontBig.DrawText( 2, 40, $ffffffff,
                                ('Press F1 for help') );
	end;
    }
    // End the scene.
    m_pd3dDevice.EndScene();

    result:=S_OK;
end;

function CDmy3DApplication.RestoreDeviceObjects: HRESULT;
var
    ret: Integer; hr: HRESULT;
    lightdir,lightcol,lightpos: TD3DVector;
begin
	// Cg̃Zbg
	lightdir.x := 0.0; lightdir.y := -2.0; lightdir.z := 1.0;
	lightcol.x := 128.0; lightcol.y := 128.0; lightcol.z := 128.0;


	//s
	ret := E3DSetDirectionalLight( m_lightid, lightdir, lightcol, m_pd3dDevice );

	//|CgCg
	lightpos.x := 0.0; lightpos.y := 500.0; lightpos.z := 0.0;
	lightcol.x := 255.0; lightcol.y := 0.0; lightcol.z := 0.0;

	ret := E3DSetPointLight( m_lightid, lightpos, 2000.0, lightcol, m_pd3dDevice );

	//X|bgCg
	lightpos.x := 0.0; lightpos.y := 200.0; lightpos.z := -2000.0;
	lightcol.x := 0.0; lightcol.y := 255.0; lightcol.z := 0.0;
	//ret := E3DSetSpotLight( m_lightid, lightpos, lightdir, 3000.0, 30.0, lightcol, m_pd3dDevice );

////////////

	if( m_d3dxsprite = Nil )then begin
		hr := D3DXCreateSprite( m_pd3dDevice, m_d3dxsprite );
		if( hr <> D3D_OK )then begin
			ASSERT( Boolean(0) );
			Result:=-1;
		end;
	end;

    m_pFont.RestoreDeviceObjects();
    m_pFontBig.RestoreDeviceObjects();

	ret := E3DRestore( m_girl1.handlerid, m_pd3dDevice, m_hWnd );

	ret := E3DRestore( m_girl2.handlerid, m_pd3dDevice, m_hWnd );

	ret := E3DRestore( m_ground.handlerid, m_pd3dDevice, m_hWnd );


	//LoadMotDatáAE3DRestorełȂƑʖځBIII
	if( m_motion_initflag = 0 )then begin

		ret := E3DCreateProgressBar();
		ASSERT( Boolean(ret) );
		ret := E3DSetProgressBar( 30 );
		ASSERT( Boolean(ret) );


		ret := LoadMotData( @m_girl1,
			'ni_parts4_idling.qua', 'ni_parts4_kick.qua', 'ni_parts4_punch.qua',
			'ni_parts4_act1.qua', 'ni_parts4_defense.qua', 'ni_parts4_death.qua',
			'ni_parts4_win.qua' );

		if boolean(ret) then begin
			//DbgOut( 'CMyD3DApplication : OneTimeSceneInit : LoadMotData error !!!\n' );
			result:= -1;
            Exit;
		end;
		m_girl1.motionid := m_girl1.motcookie[MOTION_IDLE];

		ret := E3DSetMotionKind( m_girl1.handlerid, m_girl1.motionid );
		if boolean(ret) then begin
			//DbgOut( 'CMyD3DApplication : OneTimeSceneInit : LoadMotData error !!!\n' );
			result:= -1;
            Exit;
		end;

		ret := E3DSetProgressBar( 60 );
		ASSERT( Boolean(ret) );


		ret := LoadMotData( @m_girl2,
			'na_parts1_idling.qua', 'na_parts1_kick.qua', 'na_parts1_punch.qua',
			'na_parts1_act1.qua', 'na_parts1_defense.qua', 'na_parts1_death.qua',
			'na_parts1_win.qua' );
		if boolean(ret) then begin
			//DbgOut( 'CMyD3DApplication : OneTimeSceneInit : LoadMotData error !!!\n' );
			result:= -1;
            Exit;
		end;

		m_girl2.motionid := m_girl2.motcookie[MOTION_IDLE];

		ret := E3DSetMotionKind( m_girl2.handlerid, m_girl2.motionid );
		if boolean(ret) then begin
			result:= -1;
            Exit;
		end;

		ret := E3DDestroyProgressBar();
		ASSERT( not Boolean(ret) );



		m_motion_initflag := 1;

	end;


	if Boolean( m_girl1.afterimage )then begin
		ret := E3DCreateAfterImage( m_girl1.handlerid, m_pd3dDevice, m_girl1.afterimage );
		if boolean(ret) then begin
			result:= -1;
            Exit;
		end;
	end;
	if Boolean( m_girl2.afterimage )then begin
		ret := E3DCreateAfterImage( m_girl2.handlerid, m_pd3dDevice, m_girl2.afterimage );
		if boolean(ret) then begin
			result:= -1;
            Exit;
		end;
	end;

    m_pd3dDevice.SetTextureStageState( 0, D3DTSS_MINFILTER, D3DTEXF_LINEAR );
    m_pd3dDevice.SetTextureStageState( 0, D3DTSS_MAGFILTER, D3DTEXF_LINEAR );
    m_pd3dDevice.SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
    m_pd3dDevice.SetTextureStageState( 0, D3DTSS_ALPHAOP,   D3DTOP_MODULATE );//!!!!

	m_pd3dDevice.SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
	m_pd3dDevice.SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
	m_pd3dDevice.SetTextureStageState( 0, D3DTSS_ADDRESSU, D3DTADDRESS_WRAP );
	m_pd3dDevice.SetTextureStageState( 0, D3DTSS_ADDRESSV, D3DTADDRESS_WRAP );



    m_pd3dDevice.SetRenderState( D3DRS_SRCBLEND,  D3DBLEND_ONE );
    m_pd3dDevice.SetRenderState( D3DRS_DESTBLEND, D3DBLEND_ONE );
    //m_pd3dDevice.SetRenderState( D3DRS_LIGHTING,  FALSE );//_F̓\tgEFAŌvZ܂B
	m_pd3dDevice.SetRenderState( D3DRS_LIGHTING,  1 );//nʃf[^ƃr{[h́An[hEFAŌvZ܂B
    m_pd3dDevice.SetRenderState( D3DRS_CULLMODE,  D3DCULL_CCW );
    //m_pd3dDevice.SetRenderState( D3DRS_SHADEMODE, D3DSHADE_FLAT );
	m_pd3dDevice.SetRenderState( D3DRS_SHADEMODE, D3DSHADE_GOURAUD );


	m_pd3dDevice.SetRenderState( D3DRS_WRAP0, 0 );
    m_pd3dDevice.SetRenderState( D3DRS_DITHERENABLE,   1 );
    m_pd3dDevice.SetRenderState( D3DRS_SPECULARENABLE, 1 );
	m_pd3dDevice.SetRenderState( D3DRS_ZENABLE,        D3DZB_TRUE );
    m_pd3dDevice.SetRenderState( D3DRS_AMBIENT,        D3DCOLOR_COLORVALUE( 0.40, 0.40, 0.40, 1.0 ) );
	m_pd3dDevice.SetRenderState( D3DRS_NORMALIZENORMALS,  0 );
	m_pd3dDevice.SetRenderState( D3DRS_VERTEXBLEND, D3DVBF_DISABLE );

    Result:= S_OK;
end;

function CDmy3DApplication.SelectPlayMode: Integer;
begin
	DialogBoxParam( HINSTANCE,
		MAKEINTRESOURCE(IDD_PLAY_MODE),
        GetForegroundWindow(),
        @SelectPlayModeProc, 0 );

	Result:= 0;

end;


function CDmy3DApplication.SeparateFrom(e3d1, e3d2: pE3DCookie): Integer;
var
    vec, nvec: TD3DXVECTOR2;
    ret: Integer;
begin
	vec.x := e3d2.position.x - e3d1.position.x;
	vec.y := e3d2.position.z - e3d1.position.z;

	D3DXVec2Normalize( nvec, vec );
	e3d1.position.x := e3d1.position.x - m_movestep * nvec.x;
	e3d1.position.z := e3d1.position.z - m_movestep * nvec.y;

	ret := E3DSetPosition( e3d1.handlerid, e3d1.position );
	if Boolean( ret )then begin
		ASSERT( Boolean(0) );
		Result:= 1;
        Exit;
	end;

	Result:= 0;
end;

function CDmy3DApplication.SetModuleDir: Integer;
begin
	{char filename[1024];
	ZeroMemory( filename, 1024 );
	int ret;

	ret := GetModuleFileName( NULL, filename, 1024 );
	{if( ret == 0 ){
		_ASSERT( 0 );
		DbgOut( "CMyD3DApplication : SetModuleDir : GetModuleFileName error !!!\n" );
		return 1;
	}
	{int ch = '\\';
	char* lasten;
	lasten = strrchr( filename, ch );
	{if( !lasten ){
		_ASSERT( 0 );
		DbgOut( "CMyD3DApplication : SetModuleDir : strrchr error !!!\n" );
		return 1;
	}
	{int leng;
	char moduledir[1024];
	ZeroMemory( moduledir, 1024 );
	leng = lasten - filename + 1;
	strncpy( moduledir, filename, leng );

	SetEnvironmentVariable( (LPCTSTR)"MODULEDIR", (LPCTSTR)moduledir );

	//DbgOut( "CMyD3DApplication : SetModuleDir : %s\n", moduledir );
    }
	result:= 0;
end;

function CDmy3DApplication.SetMotionStep: Integer;
var
    ret,mno: Integer;
begin
	//s_MotStep {"1","2","3"}index

	for mno := 0 to MOTION_MAX-1 do begin
		ret := E3DSetMotionStep( m_girl1.handlerid, m_girl1.motcookie[mno], s_MotStep + 1 );
		if Boolean( ret )then begin
			ASSERT( Boolean(0) );
			result:= 1;
            exit;
        end;
		ret := E3DSetMotionStep( m_girl2.handlerid, m_girl2.motcookie[mno], s_MotStep + 1 );
		if Boolean( ret )then begin
			ASSERT( Boolean(0) );
			result:= 1;
            exit;
		end;
	end;

	result:= ret;
end;

function CDmy3DApplication.SetResDir: Integer;
var
    filename,resdir: array[0..1023]of char;
    endptr,lasten,last2en,last3en: pChar;
    ret,leng: Integer;
    ch: Char;
begin
    {
	ZeroMemory( @filename[0], 1024 );

	ret := GetModuleFileName( 0, filename, 1024 );
	if( ret = 0 )then begin
		ASSERT( false );
		//DbgOut( "CMyD3DApplication : SetResDir : GetModuleFileName error !!!\n" );
		result:= 1;
        Exit;
	end;

	ch := '\';

	lasten := strrscan( filename, ch );
	if lasten=nil then begin
		ASSERT( false );
		//DbgOut( "CMyD3DApplication : SetResDir : strrchr error !!!\n" );
		result:= 1;
        Exit;
	end;

	//*lasten = 0;

	last2en := strrscan( filename, ch );
	if( last2en<>nil ) then begin
		last2en := nil;
		last3en := strrscan( filename, ch );
		if( last3en<>nil )then begin
			if( (strcomp( last2en , 'Debug' ) = 0) or
				(strcomp( last2en , 'DEBUG' ) = 0) or
				(strcomp( last2en , 'Release' ) = 0) or
				(strcomp( last2en , 'RELEASE' ) = 0)
				)then begin

				endptr := last2en;
			end else begin
				endptr := lasten;
			end;
		end else begin
			endptr := lasten;
		end;
	end else begin
		endptr := lasten;
	end;

	lasten := '\';
	if( last2en<>nil )then
		last2en := '\';
	if( last3en<>nil )then
		last3en := '\';

	ZeroMemory( @resdir[0], 1024 );
	leng := integer(@endptr) - integer(@filename) + 1;
    //SɌ݊̂閽߂ł͂ȂEEEƎv
	strlcopy( resdir, filename, leng );

	SetEnvironmentVariable( 'RESDIR', resdir );

	//DbgOut( "CMyD3DApplication : SetResDir : %s\n", resdir );
    }
	result:= 0;
end;

procedure CDmy3DApplication.UpdateCamera;
begin
  inherited;

end;

function CDmy3DApplication.UpdateGirlState(e3d1, e3d2: pE3DCookie;
  keybuffer: TKeyBoardState; confflag, keykick, keychoppu, keydefense,
  keyleft, keyright, keyup, keydown: Integer): Integer;
var
    ret,outflag,keyid: Integer;
begin
	ret := 0;

	if( m_endflag = ENDFLAG_NONE ) then begin
		outflag := CheckOutOfRange( e3d1 );
		if Boolean( outflag ) then begin
			e3d1.motionid := e3d1.motcookie[MOTION_DEATH];
			e3d1.setflag := 1;
			e3d2.motionid := e3d2.motcookie[MOTION_WIN];
			e3d2.setflag := 1;
			m_endflag := ENDFLAG_OUTOFRANGE;

			if Boolean( e3d1.afterimage ) then begin
				e3d1.afterimage := 0;
				ret := E3DDestroyAfterImage( e3d1.handlerid );
				if Boolean( ret ) then begin
					ASSERT( Boolean(0) );
					result :=1;
                    Exit;
				end;
			end;
			if Boolean( e3d2.afterimage ) then begin
				e3d2.afterimage := 0;
				ret := E3DDestroyAfterImage( e3d2.handlerid );
				if Boolean( ret ) then begin
					ASSERT( Boolean(0) );
					result :=1;
                    Exit;
				end;
			end;
			e3d1.alpha := 1.0;
			e3d2.alpha := 1.0;
			E3DSetAlpha( e3d1.handlerid, e3d1.alpha );
			E3DSetAlpha( e3d2.handlerid, e3d2.alpha );

		end;
	end;

	if( m_endflag = ENDFLAG_NONE ) then begin
		if( e3d1.motionid = e3d1.motcookie[MOTION_KICK] ) then begin
			if( e3d1.frameno >= e3d1.framemax[MOTION_KICK] ) then begin
				e3d1.motionid := e3d1.motcookie[MOTION_IDLE];
				e3d1.setflag := 1;
			end;
		end else if( e3d1.motionid = e3d1.motcookie[MOTION_PUNCH] ) then begin
			if( e3d1.frameno >= e3d1.framemax[MOTION_PUNCH] ) then begin
				e3d1.motionid := e3d1.motcookie[MOTION_IDLE];
				e3d1.setflag := 1;
			end;
		end else if( e3d1.motionid = e3d1.motcookie[MOTION_ACT1] ) then begin
			if( e3d1.frameno >= e3d1.framemax[MOTION_ACT1] ) then begin
				e3d1.motionid := e3d1.motcookie[MOTION_IDLE];
				e3d1.setflag := 1;

				if Boolean( e3d1.afterimage ) then begin
					e3d1.afterimage := 0;
					ret := E3DDestroyAfterImage( e3d1.handlerid );
				    if Boolean( ret ) then begin
					    ASSERT( Boolean(0) );
					    result :=1;
                        Exit;
				    end;
				end;
				e3d1.alpha := 1.0;
				E3DSetAlpha( e3d1.handlerid, e3d1.alpha );

			end;
		end else if( e3d1.motionid = e3d1.motcookie[MOTION_DEFENSE] ) then begin
			if Boolean(keybuffer[keydefense] and $80) then begin
				e3d1.defenseflag := 1;
			end else begin
				e3d1.defenseflag := 0;
			end;
		end else begin
			if( confflag = 0 ) then begin
				if( Boolean(keybuffer[keychoppu] and $80) and Boolean(keybuffer[keykick] and $80) and
					(e3d1.motionid = e3d1.motcookie[MOTION_IDLE]) ) then begin

					e3d1.motionid := e3d1.motcookie[MOTION_ACT1];
					e3d1.setflag := 2;

					e3d1.afterimage := AFTERIMAGENUM;
					ret := E3DCreateAfterImage( e3d1.handlerid, m_pd3dDevice, e3d1.afterimage );
				    if Boolean( ret ) then begin
					    ASSERT( Boolean(0) );
					    result :=1;
                        Exit;
				    end;
					e3d1.alpha := 0.4;
					E3DSetAlpha( e3d1.handlerid, e3d1.alpha );

				end else if( Boolean(keybuffer[keykick] and $80) and
					(e3d1.motionid = e3d1.motcookie[MOTION_IDLE]) ) then begin
					e3d1.motionid := e3d1.motcookie[MOTION_KICK];
					e3d1.setflag := 2;

				end else if( Boolean(keybuffer[keychoppu] and $80) and
					(e3d1.motionid = e3d1.motcookie[MOTION_IDLE]) ) then begin
					e3d1.motionid := e3d1.motcookie[MOTION_PUNCH];
					e3d1.setflag := 2;
				end else if( Boolean(keybuffer[keydefense] and $80) and
					(e3d1.motionid = e3d1.motcookie[MOTION_IDLE]) ) then begin
					e3d1.motionid := e3d1.motcookie[MOTION_DEFENSE];
					e3d1.defenseflag := 1;
					e3d1.setflag := 2;
				end;
			end;
		end;

		if( (e3d1.motionid = e3d1.motcookie[MOTION_DEFENSE]) and
			(e3d1.defenseflag = 0) ) then begin
			e3d1.motionid := e3d1.motcookie[MOTION_IDLE];
			e3d1.setflag := 1;
		end;


		if( confflag = 0 ) then begin
			if( e3d1.motionid = e3d1.motcookie[MOTION_IDLE] ) then begin
				keyid := 0;
				if Boolean( keybuffer[keyleft] and $80 ) then begin
					keyid := ID_KEY_LEFT;
				end else if Boolean( keybuffer[keyright] and $80 ) then begin
					keyid := ID_KEY_RIGHT;
				end else if Boolean( keybuffer[keyup] and $80 ) then begin
					keyid := ID_KEY_UP;
				end else if Boolean( keybuffer[keydown] and $80 ) then begin
					keyid := ID_KEY_DOWN;
				end;
				if Boolean( keyid ) then begin
					ret := MoveGirlXZ( e3d1, keyid );
				    if Boolean( ret ) then begin
					    ASSERT( Boolean(0) );
					    result :=1;
                        Exit;
				    end;
				end;
			end;
		end else begin
			if( (e3d1.motionid = e3d1.motcookie[MOTION_IDLE]) or
				(e3d1.motionid = e3d1.motcookie[MOTION_DEFENSE]) ) then begin
				ret := SeparateFrom( e3d1, e3d2 );
				    if Boolean( ret ) then begin
					    ASSERT( Boolean(0) );
					    result :=1;
                        Exit;
				    end;
			end;
		end;
	end;

	if( e3d1.setflag = 2 ) then begin
		ret := DirToTheOtherXZ( e3d1, e3d2 );
				    if Boolean( ret ) then begin
					    ASSERT( Boolean(0) );
					    result :=1;
                        Exit;
				    end;
	end;


	if Boolean( e3d1.setflag ) then begin
		ret := E3DSetMotionKind( e3d1.handlerid, e3d1.motionid );
				    if Boolean( ret ) then begin
					    ASSERT( Boolean(0) );
					    result :=1;
                        Exit;
				    end;
	end;
	if Boolean( e3d2.setflag ) then begin
		ret := E3DSetMotionKind( e3d2.handlerid, e3d2.motionid );
				    if Boolean( ret ) then begin
					    ASSERT( Boolean(0) );
					    result :=1;
                        Exit;
				    end;
	end;


	e3d1.frameno := E3DSetNewPause( e3d1.handlerid );
	if( e3d1.frameno < 0 ) then begin
		(*DbgOut( "CMyD3DApplication : FrameMove : SetNewPause error !!!\n" );
		_ASSERT( 0 );
		return -1;*)
	end;

	result:= 0;
end;

end.
